<?php
/*
  $Id: textmaster.php,v 1.1 2008/01/13 
  textmaster Originally Created by: Jack York AKA Jack_mcs at oscommerce-solution.com
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce
  Portions Copyright 2009 oscommerce-solution.com

  Released under the GNU General Public License
*/
 
  require('includes/application_top.php');
  require('includes/languages/' . $language . '/' . 'textmaster.php');
  require('includes/functions/textmaster.php');
  
//  define('HTML_EDITOR', 'CKEditor');  //remove the two slashes to enable this editor
//  define('HTML_EDITOR', 'FCKEditor'); //only one line should be enabled  
//  define('HTML_EDITOR', 'tinyMCE');   

  $backupDir = DIR_FS_ADMIN . 'backups_textmaster/';
 
  $currentEdit = EDITOR_FOR_NONE;
  if (isset($_POST['total_sections'])) {
      $lastEdit = (isset($_POST['current_edit']) ? $_POST['current_edit'] - 100 : '' ); //hidden field fails on 0 so remove added amount
      for ($i = 0; $i < $_POST['total_sections']; ++$i) {
          if (isset($_POST['html_editor_status_'.$i]) && $_POST['html_editor_status_'.$i] == 'on') {
              $tmpEdit = $i;
              if ($tmpEdit != $lastEdit) {
                  $currentEdit = $tmpEdit;
                  break;
              }
          }
      } 
  }  
  
  $editorStatus = (isset($_POST['html_editor_status_all']) && $_POST['html_editor_status_all'] == 'on') ? ' checked ' : '';
  $use_html_editor = $currentEdit == EDITOR_FOR_NONE && empty($editorStatus) ?  EDITOR_FOR_NONE : HTML_EDITOR;
    
  $foundDefine = false;
  $fp = array();
  $initialDir = 'includes/languages/';        //DIR_WS_INCLUDES; -use this instead to allow include files to be edited
  $pathDir = DIR_FS_CATALOG . $initialDir;
  $restoreEnable = ' checked disabled ';  //control the restore button
  $selectedDir = DEF_SELECT_DIRECTORY;
  $selectedFile = DEF_SELECT_FILE;
  $textArray = array();
  $textString = ''; 
 
  /********************** BEGIN VERSION CHECKER *********************/
  if (file_exists(DIR_WS_FUNCTIONS . 'version_checker.php')) {
      require(DIR_WS_LANGUAGES . $language . '/version_checker.php');
      require(DIR_WS_FUNCTIONS . 'version_checker.php');
      $contribPath = 'http://addons.oscommerce.com/info/5927';
      $currentVersion = 'TextMaster V 1.3';
      $contribName = 'TextMaster V';
      $versionStatus = '';
  }
  /********************** END VERSION CHECKER *********************/
   
      /********************** CHECK THE VERSION ***********************/
      if ($_POST['action'] == 'getversion') {
          if (isset($_POST['version_check']) && $_POST['version_check'] == 'on') {
              $versionStatus = AnnounceVersion($contribPath, $currentVersion, $contribName);
          }
      }
  
   
  if (isset($_POST['current_directory']) && $_POST['selected_directory'] != DEF_SELECT_DIRECTORY) {
      $selectedDir = $_POST['selected_directory'];  
      $pathDir = unserialize(str_replace("\\", "", $_POST['pathDir']));
      $d = explode('/', $pathDir);

      /************************ PARENT SELECTED IN DIRECTORY LIST ***************************/  
      if (isset($_POST['selected_directory']) && $_POST['selected_directory'] === "..parent") { //backup a level
          unset($d[count($d)-2]);
          $selectedFile = DEF_SELECT_FILE;
          $pathDir = implode("/", $d);
          $pathDir = (substr($pathDir, strlen($pathDir) - 1)) == "/" ? $pathDir : $pathDir . "/";
          $selectedDir = $d[count($d)-2];
      } else {
          if ($selectedDir !== $d[count($d)-2]) { //same directory - probably a file change
              $pathDir = rtrim($pathDir, "/"); //may or may not exist
              $pathDir .= '/'.$_POST['selected_directory'] . '/';
          } else {
              $selectedFile = $_POST['file']; //save for redisplay
              if (isset($_POST['restore_file'])) {
                  $prev_name = RemoveDateFromPath($_POST['restore_file']);
                  if ($selectedFile !== $prev_name) {  //the file being worked on has changed
                      $_POST['restore_file'] = BKUP_SELECT_FILE; //force bypass of restore section
                  }
              }
          }  
      }
  } else {
       $pathDir = DIR_FS_CATALOG . $initialDir; //basic path as in configure file
       if ($_POST['file'] !== DEF_SELECT_FILE) { //file was selected from default directory
           $selectedFile = $_POST['file'];
       }  
  }  

  $pathFile = DIR_FS_CATALOG . DIR_WS_LANGUAGES . $language . '/';
  $action = (isset($_POST['action']) ? $_POST['action'] : '');
 
  /************************ REMOVE FILE FROM BACCKUP ***************************/
  if (! isset($_POST['update_x']) && isset($_POST['remove_file']) && $_POST['remove_file'] != BKUP_SELECT_FILE) {
      $dir = $pathDir;
      $file =  $_POST['remove_file'];
      $fullPath = $dir . $file ;          
      $backupLocn = $backupDir . substr($fullPath, strlen(DIR_FS_CATALOG));
      if (unlink($backupLocn)) {
          $messageStack->add(sprintf(REMOVE_SUCCESS, $backupLocn), 'success');
      } else {
          $messageStack->add(sprintf(REMOVE_FAILED, $backupLocn), 'error');
      }
  
  }
  
  /************************ RESTORE FILE FROM BACCKUP ***************************/
  else if (! isset($_POST['update_x']) && isset($_POST['restore_file']) && $_POST['restore_file'] != BKUP_SELECT_FILE) {
      $dir = $pathDir;
      $file =  $_POST['restore_file'];
      $fullPath = $dir . $file ;          
      $backupLocn = $backupDir . substr($fullPath, strlen(DIR_FS_CATALOG));
              
      $dest = RemoveDateFromPath($fullPath);
      if ((RestoreBackup($backupLocn, $dest))) { //restore the selected file 
 
          $messageStack->add(sprintf(RESTORE_SUCCESS, $backupLocn), 'success');
 
          $currentEdit = (int)$_POST['current_edit']; //re-enable the html editor for the correct box
          $foundDefine = SetupArrays($fp, $backupLocn, $textArray, $textString);  //read in the restored file
          
          if ($foundDefine === FALSE) { //note case
              $messageStack->add(sprintf(OPEN_FAILED, $dest), 'error'); 
          } else {
              $backupLocn = $backupDir . substr($dest, strlen(DIR_FS_CATALOG));
              $restoreEnable = BackupExists($backupLocn);
          }      
      } else {
          $messageStack->add(sprintf(RESTORE_FAILED, $backupLocn), 'error');
      }      
  }  
  
  /************************ CANCEL PICKED ON FILE - JUST RESET ***********************/  
  else if (tep_not_null($action) && isset($_POST['cancel_x'])) {
      $selectedFile = DEF_SELECT_FILE;
  }
  
  /************************ READ IN THE CHANGED FILE ***************************/  
  else if (tep_not_null($action) && isset($selectedFile) && $selectedFile != DEF_SELECT_FILE) {
      $dir = $pathDir;
      $file =  $selectedFile;
      $fullPath = $dir . $file; 
      
      if (tep_not_null($file)) { 
          if (tep_not_null($msg = CanWriteToFile($fullPath))) {
              $messageStack->add($msg);
          } else {
          
              $foundDefine = SetupArrays($fp, $fullPath, $textArray, $textString);
              $backupLocn = $backupDir . substr($fullPath, strlen(DIR_FS_CATALOG));
              $restoreEnable = BackupExists($backupLocn);
              
              /************************ SAVE THE CHANGES ***************************/
              if (isset($_POST['update_x'])) {
                  if (isset($_POST['found_define']) && $_POST['found_define'] == 'on') {
                      $block = false;         
                      $ctr = 0;  
                      $new_contents = array();
 
                      for ($idx = 0; $idx < count($fp); ++$idx) {
                           if (($pos1 = strpos($fp[$idx], "define('")) !== FALSE  && IsVariableText($fp[$idx])) {                           //contains a define with text - defined 2nd arguments are skipped
                                $block = true; //a define section is being read 
                                $define = "textmaster_define_$ctr"; 
                                $text = "textmaster_text_$ctr";
                                $tmpDefine = tep_db_prepare_input($_POST[$define]);
                                $tmpText = $_POST[$text];                               
                                $new_contents[] = sprintf("define('%s', '%s');\n",$tmpDefine, $tmpText);
                                $ctr++;
                           }
  
                           if ($block) { //ignore all original define lines for this block
                               if (strpos($fp[$idx], ");") !== FALSE) { //the block has completed
                                  $block = false;
                               }
                           } else { 
                               $new_contents[] = $fp[$idx]; //add all lines not in a define block
                           }  
                      }
                                
                      $fp = array();
                      $fp = array_slice($new_contents, 0);
 
                  } else {
                      $fp = array();
                      $fp = explode("\n", $_POST['textmaster_string']);
                    if (get_magic_quotes_gpc()) {
                      function stripslashes_array($array) {
                          return is_array($array) ? array_map('stripslashes_array', $array) : stripslashes($array);
                  }    
                      $fp = stripslashes_array($fp);
                    }
                  }    
                  $src = $fullPath;
                  $dest = $backupDir . substr($fullPath, strlen(DIR_FS_CATALOG));
                  $backupLocn = substr(dirname($fullPath), strlen(DIR_FS_CATALOG));

                  if (tep_not_null(($msg = CreateBackup($src, $dest, $backupLocn, $backupDir)))) { //create a backup first 
                      $messageStack->add($msg, 'error');
                  } else {  //backup was created so change file
                      if (tep_not_null(($msg = SaveText($fullPath, $fp)))) {
                          $messageStack->add($msg, 'error');
                      } else {
                          $messageStack->add(SAVE_SUCCESS, 'success');  
                      }  
                  }

                  $currentEdit = (int)$_POST['current_edit']; //re-enable the html editor for the correct box
                  $foundDefine = SetupArrays($fp, $fullPath, $textArray, $textString);  
                  $backupLocn = $backupDir . substr($fullPath, strlen(DIR_FS_CATALOG));
                  $restoreEnable = BackupExists($backupLocn); 
              } 
          }    
      }
  } 

  /***************  CREATE DIRECTORY and FILE LISTS *****************/ 
  $dirs = array();
  $filesTM = array();

  clearstatcache();  //clear cache for new read

  if ($handle = opendir($pathDir)) {
     $dirs[] = array('id' => $selectedDir, 'text' => $selectedDir);
     
     if (substr($pathDir, -strlen($initialDir)) !== $initialDir) {  //don't allow backing up before the initial directory
         $dirs[] = array('id' => '..parent', 'text' => '..parent');         
     }
     
     $filesTM[] = array('id' => DEF_SELECT_FILE, 'text' => DEF_SELECT_FILE);

     while (false !== ($file = readdir($handle))) {
       if(! is_dir($pathDir.$file)) {
          if( substr($file, -4, 4) === ".php") { //only look at php files
              $filesTM[] = array('id' => $file, 'text' => $file);
          }  
       } else if ($file != "." && $file != "..") { 
          if (substr($file, -strlen("images")) !== "images") { //don't list images directories
              $dirs[] = array('id' => $file, 'text' => $file);
          }  
       } 
       
      $filesTM = record_sort($filesTM, "text");
    }
    
 		 closedir($handle);
  }  

  $restoreFiles = array();
  if (isset($_POST['file']) && $_POST['file'] != DEF_SELECT_FILE) {
      $backupLocn = $backupDir . substr($fullPath, strlen(DIR_FS_CATALOG));
      $backupPath = RemoveFileFromPath($backupLocn);
      $restoreFiles = GetSavedFiles($backupPath, $_POST['file'], $restoreEnable);
      $restoreFiles = record_sort($restoreFiles, "text");
  }
 
  require('includes/template_top.php'); 
?>
<style type="text/css">
div.section_row {clear:both; margin-left:auto; margin-right:auto; width:90%; padding-top:0px; }
div.section_column a:link { float:left; width:80px; padding-left:10px; color:#cc0000; text-align:center;}
div.shadow { width:100px; height:12px; background-color:#D8EAF7; box-shadow: 6px 6px 5px #888888; padding:0px 0px 4px; border-radius:6px;}
</style>
<script type="text/javascript">
function showHelp(page) { 
	$( "#tm_help" ).dialog({
  show: "fade",
  hide: "fade",
  position: ['middle',100], 
  width: 600,
  height: 400,
  modal: true,
  open: function(event, ui)	{
   $(this).load(page);
  }
 });
}
</script>
<?php
if ($use_html_editor == 'CKEditor') {
    echo '<script type="text/javascript" src="../ckeditor/ckeditor.js"></script>';
} else if ($use_html_editor == 'tinyMCE') {
    // START tinyMCE Anywhere
    if (file_exists("includes/javascript/tiny_mce/general.php")) {
      $languages = tep_get_languages(); // Get all languages
      // Build list of textareas to convert
      $allon = (isset($_POST['html_editor_status_all']) && $_POST['html_editor_status_all'] == EDITOR_FOR_ALL) ? true : false;
    
      if (isset($_POST['found_define']) && $_POST['found_define'] == 'off') {
        if ($allon) {
          $mce_str = "textmaster_string";
          $editorStatus = EDITOR_FOR_ALL + 1;
        } else {
          $mce_str = '';
          $editorStatus = EDITOR_FOR_ALL;
        }
      } else {
        for ($i = 0; $i < count($textArray); ++$i) {
          if ($allon || (isset($_POST['html_editor_status']) && $_POST['html_editor_status'] == $i) || ($currentEdit != DEF_SELECT_DIRECTORY && $currentEdit == $i)) {
            $str.="textmaster_text_$i,";
          }
        }
        $mce_str = rtrim ($str,","); // Removed the last comma from the string.
      }
      echo '<script language="javascript" type="text/javascript" src="includes/javascript/tiny_mce/tiny_mce.js"></script>';
      include "includes/javascript/tiny_mce/general.php";
    } else {
      $messageStack->add(TINYMCE_NOT_FOUND, 'error');
    } 
     // END tinyMCE Anywhere
} else if ($use_html_editor == 'FCKEditor') { 
    //nothing needed for this editor    
}
?>
 <table border="0" width="100%" cellspacing="0" cellpadding="0">
  <tr>
    <td width="100%" valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="0">
     <tr>
    <td width="100%" valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="2">
       <tr>
        <td><table border="0" width="100%" cellspacing="0" cellpadding="0">
         <tr>
            <td class="pageHeading" valign="top"><?php echo str_replace(" ", "&nbsp;", $currentVersion); ?></td>
         </tr>
         <tr>
            <td class="do_small" valign="top"><?php echo HEADING_TITLE_SUPPORT_THREAD; ?></td>
         </tr>     
        </table></td>
        <td><table border="0" width="100%">
         <tr>
          <td class="do_small" align="right"><?php echo HEADING_TITLE_AUTHOR; ?></td>
         </tr>
         <?php
         if (function_exists('AnnounceVersion')) {
            if (TEXTMASTER_ENABLE_VERSION_CHECKER == 'true') {
         ?>
               <tr>
                  <td class="do_small" align="right" style="font-weight: bold; color: red;"><?php echo AnnounceVersion($contribPath, $currentVersion, $contribName); ?></td>
               </tr>
         <?php } else if (tep_not_null($versionStatus)) {
           echo '<tr><td class="do_small" align="right" style="font-weight: bold; color: red;">' . $versionStatus . '</td></tr>';
         } else {
           echo tep_draw_form('version_check', 'textmaster.php', '', 'post') . tep_draw_hidden_field('action', 'getversion');
         ?>
               <tr>
                  <td class="do_small" align="right" style="font-weight: bold; color: red;"><INPUT TYPE="radio" NAME="version_check" onClick="this.form.submit();"><?php echo TEXT_VERSION_CHECK_UPDATES; ?></td>
               </tr>
           </form>
         <?php } } else { ?>
           <tr>
              <td class="do_small" align="right" style="font-weight: bold; color:red;"><?php echo TEXT_MISSING_VERSION_CHECKER; ?></td>
           </tr>
         <?php } ?>
        </table></td>
       </tr>
       <tr>
        <td class="HTC_subHead" colspan="2"><?php echo TEXT_HELP; ?></td>    
       </tr>
  <!-- Begin of TextMaster -->
 
  <tr>
      <td colspan="2">
      <?php echo tep_draw_form('textmaster', 'textmaster.php', '', 'post') . tep_draw_hidden_field('action', 'process') . tep_draw_hidden_field('current_directory', $pathDir) . tep_draw_hidden_field('found_define', (($foundDefine) ? 'on' : 'off')); ?></td>
      <table border="0" width="100%" cellpadding="0" cellspacing="0">
    <tr>
     <td><table border="0" width="100%" cellpadding="0" style=" background-color:#D8EAF7">
      <tr>
           <td class="smallText"><div style="border-top:solid 1px #BBC3D3; padding-bottom:5px"></div>
         <div style="float:left; width:100%">
           <div style="float:left; font-weight:bold"><?php echo TEXT_SELECT_DIRECTORY; ?></div>
           <div style="float:left; padding-left:10px"><?php echo tep_draw_hidden_field('pathDir', serialize($pathDir)) . tep_draw_pull_down_menu('selected_directory', $dirs, $selectedDir, 'onChange="this.form.submit();"'); ?></div>
           <div style="float:left; padding-left:40px; font-weight:bold"><?php echo TEXT_SELECT_FILE; ?></div>
           <div style="float:left; padding-left:10px"><?php echo tep_draw_pull_down_menu('file', $filesTM, $selectedFile, 'onChange="this.form.submit();"'); ?></div>
         </div>
           </td>
     </table></td>
    </tr>
    <tr>       
     <td><table border="0" width="100%" cellpadding="0" style=" background-color:#D8EAF7">
      <tr> 
       <td class="smallText">
         <div style="float:left; width:100%; border-bottom:solid 1px #BBC3D3; padding-bottom:5px">
           <div style="float:left; font-weight:bold"><?php echo TEXT_ENABLE_HTML_EDITOR; ?></div>
           <div style="float:left; padding-left:10px"><input type="checkbox" name="html_editor_status_all" <?php echo $editorStatus; ?> onChange="this.form.submit();" ></div>
           <div style="float:left; padding-left:83px; font-weight:bold"><?php echo TEXT_RESTORE_FILE; ?></div>
           <div style="float:left; padding-left:10px"><?php echo tep_draw_pull_down_menu('restore_file', $restoreFiles, '', $restoreEnable . ' onChange="this.form.submit();"'); ?></div>
           <div style="float:left; padding-left:20px; font-weight:bold"><?php echo TEXT_REMOVE_FILE; ?></div>
           <div style="float:left; padding-left:10px"><?php echo tep_draw_pull_down_menu('remove_file', $restoreFiles, '', $restoreEnable . ' onChange="this.form.submit();"'); ?></div>
         </div>
       </td>              
      </tr>
     </table></td>  
    </tr>       
 
  

    <tr>
     <td><table border="0" width="100%">        
     <?php if (tep_not_null($textString)) { ?>
      <tr>
       <td><table border="0" width="100%">
        <tr>
          <td class="smallText" align="left"><?php echo TEXT_ENABLE_HTML_EDITOR . tep_draw_hidden_field('html_editor_string_status', $mce_str); ?><input type="checkbox" name="html_editor_status_string" value="" <?php echo $checked; ?>   onChange="this.form.submit();"  >&nbsp;&nbsp;&nbsp;  </td>
        </tr>
       </table></td> 
      </tr>        
      <tr>
       <td class="main"><?php echo tep_draw_textarea_field('textmaster_string', 'soft', 120, 5, $textString, '', false) . tep_draw_hidden_field('textmaster_define_' . $i, $textArray[$i]['define']); ?></td>
      </tr>
     <?php 
      } else {    
      $ttlSections = count($textArray);
          for ($i = 0; $i < $ttlSections; ++$i) {  ?>
      <tr>
       <td><table border="0" width="100%">
        <tr>
          <td class="main" style="font-weight:bold"><?php echo $textArray[$i]['define'] . ' (starts at line '. $textArray[$i]['line'] . ')'?></td>
          <td class="smallText" align="right"><?php echo TEXT_ENABLE_HTML_EDITOR; ?><input type="checkbox" name="html_editor_status_<?php echo $i; ?>" <?php echo ($i == $currentEdit ? ' checked ' : ''); ?> onClick="this.form.submit();" >&nbsp;&nbsp;&nbsp;  </td>
        </tr>
       </table></td> 
      </tr>
      <tr>
            <td class="main" width="100%">
          <?php 
          if ($currentEdit != $i && empty($editorStatus)) {
              echo tep_draw_textarea_field('textmaster_text_'. $i, 'soft', 120, 5, (isset($textArray[$i]['text']) ? stripslashes($textArray[$i]['text']) : ''), '', false); 
          } else if ($use_html_editor == 'CKEditor') { 
              echo tep_draw_textarea_field('textmaster_text_'. $i, 'soft', '220', '5', (isset($textArray[$i]['text']) ? stripslashes($textArray[$i]['text']) : ''), 'class="ckeditor"', false);              
          } else if ($use_html_editor == 'tinyMCE') {
              echo tep_draw_textarea_field('textmaster_text_'. $i, 'soft', 120, 5, (isset($textArray[$i]['text']) ? stripslashes($textArray[$i]['text']) : ''), '', false);
          } else if ($use_html_editor == 'FCKEditor') {
              echo tep_draw_fckeditor('textmaster_text_'. $i,'600','300',(isset($textArray[$i]['text']) ? stripslashes($textArray[$i]['text']) : '')); 
          } else {
              echo tep_draw_textarea_field('textmaster_text_'. $i, 'soft', 120, 5, (isset($textArray[$i]['text']) ? stripslashes($textArray[$i]['text']) : ''), '', false);
          }
          
          echo tep_draw_hidden_field('textmaster_define_' . $i, $textArray[$i]['define']);
          ?>
        </td>
      </tr>
      <tr>
       <td><?php echo tep_draw_separator('pixel_trans.gif', '100%', '10'); ?></td>
      </tr>            
      <?php 
       } 
       echo tep_draw_hidden_field('total_sections', $ttlSections) .
            tep_draw_hidden_field('current_edit', ($currentEdit + 100)); //hidden field fails on 0 so add an amount
      ?>         
     </table></td>  
    </tr>            
    <?php } ?>
    
    <?php if (tep_not_null($textString) || count($textArray)) { ?>
    <tr>
     <td align="center"><table border="0" width="30%">
      <tr>
     <td class="main"><?php echo tep_image_submit('button_update.gif', IMAGE_UPDATE, 'name="update"'); ?></td>
     <td class="main"><?php echo tep_image_submit('button_cancel.gif', IMAGE_CANCEL, 'name="cancel"'); ?></td>
      </tr>
     </table></td>  
    </tr>       
    <?php } ?>
       </table>
   </form>
   </td>
  </tr>
  <!-- end of Textmaster -->  

    </table></td>
  </tr>
</table>

<?php
  require('includes/template_bottom.php');
  require('includes/application_bottom.php');
?>
