<?php
/*
  $Id: textmaster.php,v 1.1 2008/01/13 
  textmaster Originally Created by: Jack York AKA Jack_mcs at oscommerce-solution.com
  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce
  Portions Copyright 2009 oscommerce-solution.com

  Released under the GNU General Public License
*/
 
  require('includes/application_top.php');
  require('includes/languages/' . $language . '/' . 'textmaster.php');
  require('includes/functions/textmaster.php');
  
  $backupDir = DIR_FS_ADMIN . 'backups_textmaster/';
  $currentEdit = EDITOR_FOR_NONE;
  
  if (isset($_POST['total_sections'])) {
      $lastEdit = (isset($_POST['current_edit']) ? $_POST['current_edit'] - 100 : '' ); //hidden field fails on 0 so remove added amount
      for ($i = 0; $i < $_POST['total_sections']; ++$i) {
          if (isset($_POST['html_editor_status_'.$i]) && $_POST['html_editor_status_'.$i] == 'on') {
              $tmpEdit = $i;
              if ($tmpEdit != $lastEdit) {
                  $currentEdit = $tmpEdit;
                  break;
              }
          }
      } 
  }  
  
  $editorStatus = (isset($_POST['html_editor_status_all']) && $_POST['html_editor_status_all'] == 'on') ? ' checked ' : '';
  $use_html_editor = $currentEdit == EDITOR_FOR_NONE && empty($editorStatus) ?  EDITOR_FOR_NONE : HTML_EDITOR;
    
  $foundDefine = false;
  $fp = [];
  $initialDir = 'includes/languages/';        //DIR_WS_INCLUDES; -use this instead to allow include files to be edited
  $pathDir = DIR_FS_CATALOG . $initialDir;
  $restoreEnable = ' checked disabled ';  //control the restore button
  $selectedDir = DEF_SELECT_DIRECTORY;
  $selectedFile = DEF_SELECT_FILE;
  $textArray = [];
  $textString = ''; 
 
  /********************** BEGIN VERSION CHECKER *********************/
  if (file_exists('includes/functions/version_checker.php')) {
      require('includes/languages/' . $language . '/version_checker.php');
      require('includes/functions/version_checker.php');
      $contribPath = 'https://apps.oscommerce.com/AR8qG&textmaster-v-1-0';
      $currentVersion = 'TextMaster V 1.4';
      $contribName = 'TextMaster V';
      $versionStatus = '';
  }
  /********************** END VERSION CHECKER *********************/
   
  /********************** CHECK THE VERSION ***********************/
  if ($_POST['action'] == 'getversion') {
      if (isset($_POST['version_check']) && $_POST['version_check'] == 'on') {
          $versionStatus = AnnounceVersion($contribPath, $currentVersion, $contribName);
      }
  }       

  if (isset($_POST['current_directory']) && $_POST['selected_directory'] != DEF_SELECT_DIRECTORY) {
      $selectedDir = $_POST['selected_directory'];  
      $pathDir = unserialize(str_replace("\\", "", $_POST['pathDir']));
      $d = explode('/', $pathDir);

      /************************ PARENT SELECTED IN DIRECTORY LIST ***************************/  
      if (isset($_POST['selected_directory']) && $_POST['selected_directory'] === "..parent") { //backup a level
          unset($d[count($d)-2]);
          $selectedFile = DEF_SELECT_FILE;
          $pathDir = implode("/", $d);
          $pathDir = (substr($pathDir, strlen($pathDir) - 1)) == "/" ? $pathDir : $pathDir . "/";
          $selectedDir = $d[count($d)-2];
      } else {
          if ($selectedDir !== $d[count($d)-2]) { //same directory - probably a file change
              $pathDir = rtrim($pathDir, "/"); //may or may not exist
              $pathDir .= '/'.$_POST['selected_directory'] . '/';
          } else {
              $selectedFile = $_POST['file']; //save for redisplay
              if (isset($_POST['restore_file'])) {
                  $prev_name = RemoveDateFromPath($_POST['restore_file']);
                  
   // echo 'cmp '.$selectedFile . ' - ' . $prev_name.'<br>';
    
                  if ($selectedFile !== $prev_name) {  //the file being worked on has changed
                      $_POST['restore_file'] = BKUP_SELECT_FILE; //force bypass of restore section
                  }
              }
          }  
      }
  } else {
       $pathDir = DIR_FS_CATALOG . $initialDir; //basic path as in configure file
       if ($_POST['file'] !== DEF_SELECT_FILE) { //file was selected from default directory
           $selectedFile = $_POST['file'];
       }  
  }  

  $pathFile = DIR_FS_CATALOG . 'includes/languages/' . $language . '/';
  $action = (isset($_POST['action']) ? $_POST['action'] : '');
 
  /************************ REMOVE FILE FROM BACCKUP ***************************/
  if (isset($_POST['remove_file']) && $_POST['remove_file'] != BKUP_SELECT_FILE) {
      $dir = $_POST['current_directory']; //$pathDir;
      $file = $_POST['remove_file'];
      $fullPath = $dir . $file ; 
      
      $backupLocn = $backupDir . substr($fullPath, strlen(DIR_FS_CATALOG));
      $selectedDir = $_POST['selected_directory']; //save for redisplay
      $selectedFile = $_POST['file']; //save for redisplay
      $fullPath = $dir . $_POST['file'];      
      $foundDefine = SetupArrays($fp, $fullPath, $textArray, $textString); //reload the file that was opened
  
      if (unlink($backupLocn)) {
          $messageStack->add(sprintf(REMOVE_SUCCESS, $backupLocn), 'success');
      } else {
          $messageStack->add(sprintf(REMOVE_FAILED, $backupLocn), 'error');
      }  
  }
  
  /************************ RESTORE FILE FROM BACCKUP ***************************/
  elseif (isset($_POST['restore_file']) && $_POST['restore_file'] != BKUP_SELECT_FILE) {
      $dir = $_POST['current_directory']; //$pathDir
      $file =  $_POST['restore_file'];
      $fullPath = $dir . $file ;          
      $backupLocn = $backupDir . substr($fullPath, strlen(DIR_FS_CATALOG));
         
  //  echo 'path '.$pathDir.'<br>';     
         
      $dest = RemoveDateFromPath($fullPath);
      
//echo 'restore '.$backupLocn . ' - ' . $dest.'<br>';
//die;
      
      if ((RestoreBackup($backupLocn, $dest))) { //restore the selected file 
 
          $messageStack->add(sprintf(RESTORE_SUCCESS, $backupLocn), 'success');
 
          $currentEdit = (int)$_POST['current_edit']; //re-enable the html editor for the correct box
          $foundDefine = SetupArrays($fp, $backupLocn, $textArray, $textString);  //read in the restored file
          
          if ($foundDefine === FALSE) { //note case
              $messageStack->add(sprintf(OPEN_FAILED, $dest), 'error'); 
          } else {
              $backupLocn = $backupDir . substr($dest, strlen(DIR_FS_CATALOG));
              $restoreEnable = BackupExists($backupLocn);
          }      
      } else {
          $messageStack->add(sprintf(RESTORE_FAILED, $backupLocn), 'error');
      }        
  }  
  
  /************************ CANCEL PICKED ON FILE - JUST RESET ***********************/  
  elseif (tep_not_null($action) && isset($_POST['cancel_x'])) {
      $selectedFile = DEF_SELECT_FILE;
  }
  
  /************************ READ IN THE CHANGED FILE ***************************/  
  elseif (tep_not_null($action) && isset($selectedFile) && $selectedFile != DEF_SELECT_FILE) {
      $dir = $_POST['current_directory'];
      $file =  $selectedFile;
      $fullPath = $dir . $file; 
        
      
      if (tep_not_null($file)) { 
          if (tep_not_null($msg = CanWriteToFile($fullPath))) {
              $messageStack->add($msg);
          } else {
          
              $foundDefine = SetupArrays($fp, $fullPath, $textArray, $textString);
              $backupLocn = $backupDir . substr($fullPath, strlen(DIR_FS_CATALOG));
              $restoreEnable = BackupExists($backupLocn);
                     
              /************************ SAVE THE CHANGES ***************************/
              if (isset($_POST['update_x']) && $_POST['update_x'] == 'yes') {
                  if (isset($_POST['found_define']) && $_POST['found_define'] == 'on') {
                      $block = false;         
                      $ctr = 0;  
                      $new_contents = [];
 
                      for ($idx = 0; $idx < count($fp); ++$idx) {
                           if (($pos1 = strpos($fp[$idx], "define('")) !== FALSE  && IsVariableText($fp[$idx])) {                           //contains a define with text - defined 2nd arguments are skipped
                                $block = true; //a define section is being read 
                                $define = "textmaster_define_$ctr"; 
                                $text = "textmaster_text_$ctr";
                                $tmpDefine = tep_db_prepare_input($_POST[$define]);
                                $tmpText = addslashes($_POST[$text]);                               
                                $new_contents[] = sprintf("define('%s', '%s');\n",$tmpDefine, $tmpText);
                                $ctr++;
                           }
  
 

                           if ($block) { //ignore all original define lines for this block
                               if (strpos($fp[$idx], ");") !== FALSE) { //the block has completed
                                  $block = false;
                               }
                           } else { 
                               $new_contents[] = $fp[$idx]; //add all lines not in a define block
                           }  
                      }

                      $fp = [];
                      //$fp = array_slice($new_contents, 0);
              		      $fp = $new_contents;
                      
                  } else {
                      $fp = [];
                      $fp = explode("\n", $_POST['textmaster_string']);
    
                      if (get_magic_quotes_gpc()) {
                        function stripslashes_array($array) {
                            return is_array($array) ? array_map('stripslashes_array', $array) : stripslashes($array);
                      }    
                      $fp = stripslashes_array($fp);
                    }
                  }    

                  $src = $fullPath;
                  $dest = $backupDir . substr($fullPath, strlen(DIR_FS_CATALOG));
                  $backupLocn = substr(dirname($fullPath), strlen(DIR_FS_CATALOG));

                  if (tep_not_null(($msg = CreateBackup($src, $dest, $backupLocn, $backupDir)))) { //create a backup first 
                      $messageStack->add($msg, 'error');
                  } else {  //backup was created so change file
		  
                      if (tep_not_null(($msg = SaveText($fullPath, $fp)))) {
                          $messageStack->add($msg, 'error');
                      } else {
                          $messageStack->add(SAVE_SUCCESS, 'success');  
                      }  
                  }

                  $currentEdit = (int)$_POST['current_edit']; //re-enable the html editor for the correct box
                  $foundDefine = SetupArrays($fp, $fullPath, $textArray, $textString);  
                  $backupLocn = $backupDir . substr($fullPath, strlen(DIR_FS_CATALOG));
                  $restoreEnable = BackupExists($backupLocn); 
              } 
          }    
      }
  } 

  /***************  CREATE DIRECTORY and FILE LISTS *****************/ 
  $dirs = [];
  $filesTM = [];

  clearstatcache();  //clear cache for new read

//echo 'path '.$pathDir.'<br>';
  if ($handle = opendir($pathDir)) {
     $dirs[] = ['id' => $selectedDir, 'text' => $selectedDir];
     
     if (substr($pathDir, -strlen($initialDir)) !== $initialDir) {  //don't allow backing up before the initial directory
         $dirs[] = ['id' => '..parent', 'text' => '..parent'];         
     }
     
     $filesTM[] = ['id' => DEF_SELECT_FILE, 'text' => DEF_SELECT_FILE];

     while (false !== ($file = readdir($handle))) {
       if(! is_dir($pathDir.$file)) {
          if( substr($file, -4, 4) === ".php") { //only look at php files
              $filesTM[] = ['id' => $file, 'text' => $file];
          }  
       } elseif ($file != "." && $file != "..") { 
          if (substr($file, -strlen("images")) !== "images") { //don't list images directories
              $dirs[] = ['id' => $file, 'text' => $file];
          }  
       } 
       
      $filesTM = record_sort($filesTM, "text");
    }
    
 		 closedir($handle);
  }  

  $restoreFiles = [];
  if (isset($_POST['file']) && $_POST['file'] != DEF_SELECT_FILE) {
      $backupLocn = $backupDir . substr($fullPath, strlen(DIR_FS_CATALOG));
      $backupPath = RemoveFileFromPath($backupLocn);
      $restoreFiles = GetSavedFiles($backupPath, $_POST['file'], $restoreEnable);
      $restoreFiles = record_sort($restoreFiles, "text");
  }
    
  require('includes/template_top.php'); 
?>
<style type="text/css">
div.hts-button-holder {  
 background:yellow;
 text-align:center;
 white-space:nowrap;
 border:1px solid black;
 border-radius:5px;
 box-shadow: 10px 0px 15px #888;
}	
div.hts-button a {
 background:yellow  !important;
 width:150px; 
 text-decoration:none;
}
 
</style>
<script src="//ajax.googleapis.com/ajax/libs/jqueryui/1.12.1/jquery-ui.min.js"></script>
<script type="text/javascript">
function showHelp(page) { 
	$( "#tm-help" ).dialog({
  show: "fade",
  hide: "fade",
       position: { 
            my: 'center',
            at: 'center',
            of: window
        },
   
  width: 600,
  height: 400,
  modal: true,
  open: function(event, ui)	{
   $(this).load(page);
  }
 });
}
</script>
<?php
if ($use_html_editor == 'CKEditor') {
    echo '<script type="text/javascript" src="../ckeditor/ckeditor.js"></script>';
} elseif ($use_html_editor == 'tinyMCE') {
    // START tinyMCE Anywhere
    if (file_exists("includes/javascript/tiny_mce/general.php")) {
      $languages = tep_get_languages(); // Get all languages
      // Build list of textareas to convert
      $allon = (isset($_POST['html_editor_status_all']) && $_POST['html_editor_status_all'] == EDITOR_FOR_ALL) ? true : false;
    
      if (isset($_POST['found_define']) && $_POST['found_define'] == 'off') {
        if ($allon) {
          $mce_str = "textmaster_string";
          $editorStatus = EDITOR_FOR_ALL + 1;
        } else {
          $mce_str = '';
          $editorStatus = EDITOR_FOR_ALL;
        }
      } else {
        for ($i = 0; $i < count($textArray); ++$i) {
          if ($allon || (isset($_POST['html_editor_status']) && $_POST['html_editor_status'] == $i) || ($currentEdit != DEF_SELECT_DIRECTORY && $currentEdit == $i)) {
            $str.="textmaster_text_$i,";
          }
        }
        $mce_str = rtrim ($str,","); // Removed the last comma from the string.
      }
      echo '<script language="javascript" type="text/javascript" src="includes/javascript/tiny_mce/tiny_mce.js"></script>';
      include "includes/javascript/tiny_mce/general.php";
    } else {
      $messageStack->add(TINYMCE_NOT_FOUND, 'error');
    } 
     // END tinyMCE Anywhere
} elseif ($use_html_editor == 'FCKEditor') { 
    //nothing needed for this editor    
}
?>
  <div class="row">    
    <div class="col mb-2">
      <h1 class="display-4"><?php echo str_replace(" ", "&nbsp;", $currentVersion); ?></h1>
      <div class="row"> 
         <div class="col col-sm-3 text-left align-self-left"><?php echo HEADING_TITLE_SUPPORT_THREAD; ?></div>  
         <div class="col text-right"><?php echo TEXT_HELP; ?></div>         
      </div>
    </div>          
   
    <div class="col col-sm-3 text-right align-self-left">
      <div class="row"><?php echo HEADING_TITLE_AUTHOR; ?></div>
      
        <?php  
        $name = '';
        if (function_exists('AnnounceVersion')) {
            $idParts = explode(' ', $currentVersion);
            foreach ($idParts as $part) {
               if ($part !== 'V') {
                 $name .= $part;
               } else {
                  break;
               }               
            }
            $id = $idParts[count($idParts)-1];
            if (tep_not_null($versionStatus)) { 
               echo '<div class="row"><div class="col-sm-3 align-self-left" style="font-weight: bold; color: red;white-space:nowrap;">' . $versionStatus . '</div></div>';
            } else {
               echo tep_draw_form('version_check', 'textmaster.php', '', 'post') . tep_draw_hidden_field('action', 'getversion');
            ?>
             
             <div class="row">
               <div class="  text-right align-self-left">
                 <div class="smallText" align="left" style="font-weight: bold; color: red;"><INPUT TYPE="radio" NAME="version_check" onClick="this.form.submit();"><?php echo TEXT_VERSION_CHECK_UPDATES; ?></div>
                 <div class="smallText" align="left" style="font-weight: bold; color: red;"><INPUT TYPE="radio" NAME="version_check_unreleased" onClick="window.open('http://www.oscommerce-solution.com/check_unreleased_updates.php?id=<?php echo $id; ?>&name=<?php echo $name; ?>')"><?php echo TEXT_VERSION_CHECK_UPDATES_UNRELEASED; ?></div>
               </div>   
             </div>             
            </form>
            <?php 
            } 
        } else { ?>
           <div class="row"><div class="col" style="font-weight: bold; color: red;"><?php echo TEXT_MISSING_VERSION_CHECKER; ?></div></div>
        <?php 
        } 
        ?>      
    </div>   
   </div>
   
   <?php echo tep_draw_form('textmaster-options', 'textmaster.php', '', 'post') . tep_draw_hidden_field('action', 'process') . tep_draw_hidden_field('current_directory', $pathDir) . tep_draw_hidden_field('found_define', (($foundDefine) ? 'on' : 'off')); ?></td>
   <div class="row">
     <div class="col border border-light" style=" box-shadow: 8px 8px 8px #ccc;">
       <div class="row pl-2 pt-3" style="background-color:#D8EAF7;border-top:solid 1px #BBC3D3; padding-bottom:25px">
         <div class="" style="width:150px;font-weight:bold"><?php echo TEXT_SELECT_DIRECTORY; ?></div>
         <div class="" style="padding-left:0px"><?php echo tep_draw_hidden_field('pathDir', serialize($pathDir)) . tep_draw_pull_down_menu('selected_directory', $dirs, $selectedDir, 'onChange="this.form.submit();"'); ?></div>
         <div class="" style="width:150px;padding-left:40px; font-weight:bold"><?php echo TEXT_SELECT_FILE; ?></div>
         <div class="" style="padding-left:0px"><?php echo tep_draw_pull_down_menu('file', $filesTM, $selectedFile, 'onChange="this.form.submit();"'); ?></div>
         <div class="" style="float:right;margin-left:30px;font-weight:bold;"><?php echo TEXT_ENABLE_HTML_EDITOR; ?>
             <input type="checkbox" name="html_editor_status_all" <?php echo $editorStatus; ?> onChange="this.form.submit();" ></div>
       </div>
       
       <div class="row pl-3" style="background-color:#D8EAF7;border-bottom:solid 1px #BBC3D3; padding-bottom:5px">
       <div style="width:150px;font-weight:bold"><?php echo TEXT_RESTORE_FILE; ?></div>
       <div style="float:left; padding-left:10px"><?php echo tep_draw_pull_down_menu('restore_file', $restoreFiles, TEXT_SELECT_FILE, $restoreEnable . ' onChange="this.form.submit();"'); ?></div>
       <div style="width:150px;font-weight:bold"><?php echo TEXT_REMOVE_FILE; ?></div>
       <div style="float:left; padding-left:10px"><?php echo tep_draw_pull_down_menu('remove_file', $restoreFiles, '', $restoreEnable . ' onChange="this.form.submit();"'); ?></div>
       <?php echo tep_draw_hidden_field('selectedfile', $selectedFile); ?>
       </div>
     </div>
   </div>
   </form>
   
  <!-- Begin of TextMaster -->
  <tr>
    <td width="100%" valign="top"><table border="0" width="100%" cellspacing="0" cellpadding="2">
  
    <?php echo tep_draw_form('textmaster', 'textmaster.php', '', 'post') . tep_draw_hidden_field('action', 'process') . tep_draw_hidden_field('current_directory', $pathDir) . tep_draw_hidden_field('found_define', (($foundDefine) ? 'on' : 'off')); ?></td>
    <tr>
     <td><table border="0" width="100%">        
     <?php if (tep_not_null($textString)) { ?>
      <tr>
       <td><table border="0" width="100%">
        <tr>
          <td class="smallText" align="left"><?php echo TEXT_ENABLE_HTML_EDITOR . tep_draw_hidden_field('html_editor_string_status', $mce_str); ?><input type="checkbox" name="html_editor_status_string" value="" <?php echo $checked; ?>   onChange="this.form.submit();"  >&nbsp;&nbsp;&nbsp;  </td>
        </tr>
       </table></td> 
      </tr>        
      <tr>
       <td class="main"><?php echo tep_draw_textarea_field('textmaster_string', 'soft', 120, 5, $textString, '', false) . tep_draw_hidden_field('textmaster_define_' . $i, $textArray[$i]['define']); ?></td>
      </tr>
     <?php 
      } else {    
          $ttlSections = count($textArray);
          for ($i = 0; $i < $ttlSections; ++$i) {  ?>
           <tr>
            <td><table border="0" width="100%">
             <tr>
               <td class="main" style="font-weight:bold"><?php echo $textArray[$i]['define'] . ' (starts at line '. $textArray[$i]['line'] . ')'?></td>
               <td class="smallText" align="right"><?php echo TEXT_ENABLE_HTML_EDITOR; ?><input type="checkbox" name="html_editor_status_<?php echo $i; ?>" <?php echo ($i == $currentEdit ? ' checked ' : ''); ?> onClick="this.form.submit();" >&nbsp;&nbsp;&nbsp;  </td>
             </tr>
            </table></td> 
           </tr>
           <tr>
            <td class="main" width="100%">
          <?php 
          if ($currentEdit != $i && empty($editorStatus)) {
              echo tep_draw_textarea_field('textmaster_text_'. $i, 'soft', 120, 5, (isset($textArray[$i]['text']) ? stripslashes($textArray[$i]['text']) : ''), '', false); 
          } elseif ($use_html_editor == 'CKEditor') { 
              echo tep_draw_textarea_field('textmaster_text_'. $i, 'soft', '220', '5', (isset($textArray[$i]['text']) ? stripslashes($textArray[$i]['text']) : ''), 'class="ckeditor"', false);              
          } elseif ($use_html_editor == 'tinyMCE') {
              echo tep_draw_textarea_field('textmaster_text_'. $i, 'soft', 120, 5, (isset($textArray[$i]['text']) ? stripslashes($textArray[$i]['text']) : ''), '', false);
          } elseif ($use_html_editor == 'FCKEditor') {
              echo tep_draw_fckeditor('textmaster_text_'. $i,'600','300',(isset($textArray[$i]['text']) ? stripslashes($textArray[$i]['text']) : '')); 
          } else {
              echo tep_draw_textarea_field('textmaster_text_'. $i, 'soft', 120, 5, (isset($textArray[$i]['text']) ? stripslashes($textArray[$i]['text']) : ''), '', false);
          }
          
          echo tep_draw_hidden_field('textmaster_define_' . $i, $textArray[$i]['define']);
          ?>
        </td>
      </tr>
      <tr>
       <td><?php echo tep_draw_separator('pixel_trans.gif', '100%', '10'); ?></td>
      </tr>            
      <?php 
       } 
       echo tep_draw_hidden_field('total_sections', $ttlSections) .
            tep_draw_hidden_field('current_edit', ($currentEdit + 100)); //hidden field fails on 0 so add an amount
      ?>         
     </table></td>  
    </tr>     
    <?php } ?>
    
    <?php if (tep_not_null($textString) || count($textArray)) { 
       echo tep_draw_hidden_field('file', $selectedFile) .
            tep_draw_hidden_field('update_x', 'yes') .
            tep_draw_hidden_field('selected_directory', $selectedDir) .
            tep_draw_hidden_field('pathDir', serialize($pathDir));
    ?>    
    <tr>
     <td align="center"><table border="0" width="30%">
      <tr>
     <td class="main"><?php echo tep_draw_bootstrap_button(IMAGE_UPDATE, 'fas fa-save', null, 'primary', null, 'btn-success btn-block btn-lg');; ?></td>
     <td class="main"><?php echo tep_draw_button(IMAGE_CANCEL, 'fas fa-angle-left', tep_href_link('textmaster.php')); ?></td>
      </tr>
     </table></td>  
    </tr>       
    <?php } ?>
    </forum>    
    </table> 
   </td>
  </tr>
  <!-- end of Textmaster -->  
 

<?php
 require('includes/template_bottom.php');
 require('includes/application_bottom.php');
